import prettier from "prettier";
import * as t from "io-ts";
export declare function prettierOptions(path: string): Promise<prettier.Options>;
declare const PartialOptions: t.TypeC<{
    uri: t.StringC;
    database: t.StringC;
    out: t.StringC;
    bannerComment: t.ArrayC<t.StringC>;
    enableConstEnums: t.BooleanC;
    ignoreMinAndMaxItems: t.BooleanC;
    strictIndexSignatures: t.BooleanC;
    unknownAny: t.BooleanC;
}>;
export declare type Options = t.TypeOf<typeof PartialOptions>;
export declare const defaultOptions: Options;
export declare function parseConfig(config: string): Options;
export declare function loadConfig(): Options;
/**
 * Returns the expanded environment variable if the provided value starts with
 * "$", otherwise returns the provided value as-is.
 */
export declare function expandEnv(val: string): string;
export {};
//# sourceMappingURL=options.d.ts.map