"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.expandEnv = exports.loadConfig = exports.parseConfig = exports.defaultOptions = exports.prettierOptions = void 0;
const fs_1 = __importDefault(require("fs"));
const prettier_1 = __importDefault(require("prettier"));
const t = __importStar(require("io-ts"));
function prettierOptions(path) {
    return __awaiter(this, void 0, void 0, function* () {
        const options = yield prettier_1.default.resolveConfig(path);
        return Object.assign(Object.assign({}, options), { parser: "typescript" });
    });
}
exports.prettierOptions = prettierOptions;
const PartialOptions = t.type({
    uri: t.string,
    database: t.string,
    out: t.string,
    bannerComment: t.array(t.string),
    enableConstEnums: t.boolean,
    ignoreMinAndMaxItems: t.boolean,
    strictIndexSignatures: t.boolean,
    unknownAny: t.boolean,
});
exports.defaultOptions = {
    uri: "mongodb://localhost:27017",
    database: "",
    out: "src/__generated__",
    bannerComment: [
        "/* eslint-disable */",
        "",
        "/**",
        "* This file was automatically generated by bson-schema-to-typescript.",
        "* https://www.npmjs.com/package/bson-schema-to-typescript",
        "*",
        "* Do not modify it by hand. Instead, modify the MongoDB $jsonSchema validator,",
        "* and run bson2ts to regenerate this file.",
        "*/",
    ],
    enableConstEnums: true,
    ignoreMinAndMaxItems: false,
    strictIndexSignatures: false,
    unknownAny: true,
};
function readConfig() {
    const configPath = "./bson2ts.json";
    return fs_1.default.existsSync(configPath)
        ? fs_1.default.readFileSync(configPath).toString()
        : JSON.stringify({});
}
function parseConfig(config) {
    try {
        JSON.parse(config);
    }
    catch (error) {
        throw new Error(`Invalid configuration`);
    }
    const options = JSON.parse(config);
    if (typeof options !== "object" ||
        options === null ||
        Array.isArray(options)) {
        throw new Error(`Invalid configuration`);
    }
    const mergedOptions = Object.assign(Object.assign({}, exports.defaultOptions), options);
    if (!PartialOptions.is(mergedOptions)) {
        throw new Error(`Invalid configuration`);
    }
    Object.keys(mergedOptions).forEach((key) => {
        if (!Reflect.has(exports.defaultOptions, key)) {
            throw new Error(`Invalid configuration`);
        }
    });
    return Object.assign(Object.assign({}, mergedOptions), { uri: expandEnv(mergedOptions.uri), database: expandEnv(mergedOptions.database) });
}
exports.parseConfig = parseConfig;
function loadConfig() {
    const config = readConfig();
    return parseConfig(config);
}
exports.loadConfig = loadConfig;
function getEnv(name) {
    const env = process.env[name];
    if (!env) {
        throw new Error(`${name} environment variable not defined`);
    }
    return env;
}
/**
 * Returns the expanded environment variable if the provided value starts with
 * "$", otherwise returns the provided value as-is.
 */
function expandEnv(val) {
    return val.startsWith("$") ? getEnv(val.slice(1)) : val;
}
exports.expandEnv = expandEnv;
//# sourceMappingURL=options.js.map